const express = require("express");
const router = express.Router();
const authorize = require("../../../../middlewares/authorize-sapps");
const commentService = require("./comment.service");
const redisClient = require('../../../../redisClient');

router.post("/create", authorize(), create);
router.get("/", authorize(), getAll);
router.get("/filter", authorize(), filter);
router.get("/option", authorize(), option);
router.get("/count", authorize(), count);
router.put("/:id", authorize(), update);
router.delete("/:id", authorize(), _delete);

module.exports = router;

function create(req, res, next) {
    commentService
        .create(req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function getAll(req, res, next) {
  commentService
    .getAll(req.query)
    .then((result) => res.json(result))
    .catch(next);
}


function filter(req, res, next) {
    commentService
        .filter(req.query)
        .then((result) => res.json(result))
        .catch(next);
}


function option(req, res, next) {
    commentService
        .option()
        .then((result) => res.json(result))
        .catch(next);
}

function count(req, res, next) {
    commentService
        .count()
        .then((result) => res.json(result))
        .catch(next);
}

function update(req, res, next) {
    commentService
        .update(req.params.id, req.body)
        .then((result) => res.json(result))
        .catch(next);
}

function _delete(req, res, next) {
    commentService
        .delete(req.params.id)
        .then((result) => res.json(result))
        .catch(next);
}
